%Saddle -node of periodic orbits in the Fitzhugh-Nagumo equation
%   f[0] = y[1] + y[0] -y[0]*y[0]*y[0]/3;
%   f[1] = -p[3]*(p[0]*y[0]+p[1]+p[2]*y[1]);
%
format long
%The parameters
nsteps = 5;
data = zeros(nsteps,6);

x = -1.04131

p = [1, 0.05, 1.2, 0.3921];
data(1,:) = [fhn_snf(x,p),p(4)];
p = [1, 0.05, 1.2, 0.3922];
data(2,:) = [fhn_snf(x,p),p(4)];

for j = 3:nsteps
    p(4) = data(j-1,6) + data(j-1,1)*(data(j-1,6) - data(j-2,6))/ - (data(j-1,1) - data(j-2,1))
    %x = x - data(j-1,2);
    data(j,:) = [fhn_snf(x,p),p(4)];
end
data